

{
Rename 'Em!
by Antti Kirjavainen

Cross-platform Kylix-application for multi-renaming files.

You can use any parts of this code you like.


NOTE: Those of you, who wonder why some functions are activated by
a timer - it's just to make sure the user sees the "Loading..."-text
and knows the program is busy working, not stuck.

}


unit Main;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QComCtrls, QExtCtrls, QImgList, QStdCtrls, Qt, QMenus, QTypes, IniFiles {$IFDEF LINUX}, Libc{$ENDIF};

const
        ENTER = #13 + #10;
        STATUS_READY = 'Ready.';

type
  TfrmMain = class(TForm)
    trvwLocal: TTreeView;
    lstvwLocal: TListView;
    imglstTreeView: TImageList;
    imglstListView: TImageList;
    txtPattern: TEdit;
    mnuMain: TMainMenu;
    mnuFile: TMenuItem;
    mnuExit: TMenuItem;
    N1: TMenuItem;
    mnuRefresh: TMenuItem;
    About1: TMenuItem;
    About2: TMenuItem;
    lviRename: TListView;
    grpRename_0: TGroupBox;
    cmdRename_0: TButton;
    stbStatus: TStatusBar;
    mnuRename: TMenuItem;
    mnuRename_0: TMenuItem;
    mnuRename_1: TMenuItem;
    mnuRename_2: TMenuItem;
    mnuRename_3: TMenuItem;
    mnuRename_4: TMenuItem;
    mnuRename_5: TMenuItem;
    mnuRename_6: TMenuItem;
    mnuOptions: TMenuItem;
    mnuCaseSensitive: TMenuItem;
    mnuIncludeExtension: TMenuItem;
    mnuUndo: TMenuItem;
    mnuHomepage: TMenuItem;
    N2: TMenuItem;
    mnuAdd: TMenuItem;
    mnuSelectedFiles: TMenuItem;
    mnuAllFiles: TMenuItem;
    N3: TMenuItem;
    mnuAllFilesRecursive: TMenuItem;
    N4: TMenuItem;
    mnuFolderName: TMenuItem;
    mnuClear: TMenuItem;
    lviFiles: TListView;
    cmdUp: TButton;
    mnuClearSelected: TMenuItem;
    mnuManualRename: TMenuItem;
    mnuPopUpFiles: TPopupMenu;
    mnuClearSelected2: TMenuItem;
    N5: TMenuItem;
    mnuClearAll2: TMenuItem;
    mnuPopUpLocal: TPopupMenu;
    mnuAddFile2: TMenuItem;
    N6: TMenuItem;
    mnuDeleteFile: TMenuItem;
    mnuPopUpRename: TPopupMenu;
    mnuRemoveFromList: TMenuItem;
    lblReplace1: TLabel;
    txtReplaceFrom: TEdit;
    lblReplace2: TLabel;
    txtReplaceTo: TEdit;
    grpRename_1: TGroupBox;
    cmdRename_1: TButton;
    lblAdd1: TLabel;
    txtAddText: TEdit;
    lblAdd2: TLabel;
    txtAddPosition: TEdit;
    cboAddPosition: TComboBox;
    grpRename_3: TGroupBox;
    cmdRename_3: TButton;
    grpRename_2: TGroupBox;
    cmdRename_2: TButton;
    lblAutonumber1: TLabel;
    txtAutonumberBefore: TEdit;
    lblAutoNumber2: TLabel;
    txtAutonumberStart: TEdit;
    lblAutoNumber3: TLabel;
    txtAutonumberAfter: TEdit;
    chkAutonumberZero: TCheckBox;
    optChangeCaseAllUpperCase: TRadioButton;
    optChangeCaseAllLowercase: TRadioButton;
    optChangeCaseFirstUpperCase: TRadioButton;
    optChangeCaseFirstLowerCase: TRadioButton;
    optChangeCaseOpposite: TRadioButton;
    grpRename_4: TGroupBox;
    cmdRename_4: TButton;
    txtTrimAmount: TEdit;
    cboTrimAmount: TComboBox;
    cboTrimFrom: TComboBox;
    grpRename_5: TGroupBox;
    cmdRename_5: TButton;
    txtExtension: TEdit;
    Label1: TLabel;
    grpRename_6: TGroupBox;
    cmdRename_6: TButton;
    txtAdvancedAddASCII1: TEdit;
    lblAdvancedAdd1: TLabel;
    lblAdvancedAdd2: TLabel;
    txtAdvancedAddASCII2: TEdit;
    lblAdvancedAdd3: TLabel;
    txtAdvancedAddNew: TEdit;
    cboAdvancedAddPosition: TComboBox;
    grpConfirmation: TGroupBox;
    cmdYes: TButton;
    lblConfirmation: TLabel;
    cmdNo: TButton;
    tmrCheckFileNames: TTimer;
    tmrMakeLists: TTimer;
    tmrDoRename: TTimer;
    tmrRecursive: TTimer;
    grpLoading: TGroupBox;
    lblLoading: TLabel;
    cmdCancel: TButton;
    cboPath: TComboBox;
    tmrRefresh: TTimer;
    mnuRename_7: TMenuItem;
    grpRename_7: TGroupBox;
    cmdRename_7: TButton;
    lblGetFileNames: TLabel;
    txtID3Format: TEdit;
    procedure cmdRename_0Click(Sender: TObject);
    procedure trvwLocalChange(Sender: TObject; Node: TTreeNode);
    procedure trvwLocalCollapsed(Sender: TObject; Node: TTreeNode);
    procedure trvwLocalDeletion(Sender: TObject; Node: TTreeNode);
    procedure FormCreate(Sender: TObject);
    procedure trvwLocalExpanded(Sender: TObject; Node: TTreeNode);
    procedure mnuExitClick(Sender: TObject);
    procedure About2Click(Sender: TObject);
    procedure txtPathKeyPress(Sender: TObject; var Key: Char);
    procedure FormResize(Sender: TObject);
    procedure mnuRefreshClick(Sender: TObject);
    procedure mnuCaseSensitiveClick(Sender: TObject);
    procedure mnuIncludeExtensionClick(Sender: TObject);
    procedure mnuUndoClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cmdUpClick(Sender: TObject);
    procedure mnuSelectedFilesClick(Sender: TObject);
    procedure lviFilesDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lstvwLocalDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure mnuClearSelectedClick(Sender: TObject);
    procedure mnuClearClick(Sender: TObject);
    procedure mnuAllFilesClick(Sender: TObject);
    procedure mnuFolderNameClick(Sender: TObject);
    procedure mnuAllFilesRecursiveClick(Sender: TObject);
    procedure lstvwLocalEdited(Sender: TObject; Item: TListItem;
      var S: WideString);
    procedure lviFilesItemMouseDown(Sender: TObject; Button: TMouseButton;
      Item: TListItem; const Pt: TPoint; ColIndex: Integer);
    procedure mnuDeleteFileClick(Sender: TObject);
    procedure lstvwLocalItemMouseDown(Sender: TObject;
      Button: TMouseButton; Item: TListItem; const Pt: TPoint;
      ColIndex: Integer);
    procedure mnuRemoveFromListClick(Sender: TObject);
    procedure lviRenameMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnuAddClick(Sender: TObject);
    procedure mnuRename_0Click(Sender: TObject);
    procedure cboAddPositionSelect(Sender: TObject);
    procedure txtExtensionKeyPress(Sender: TObject; var Key: Char);
    procedure cmdNoClick(Sender: TObject);
    procedure HideViewControls(const bVisible: Boolean);
    procedure lviRenameDblClick(Sender: TObject);
    procedure cmdYesClick(Sender: TObject);
    procedure CheckFileNames(const bNag: Boolean);
    procedure lviRenameEdited(Sender: TObject; Item: TListItem;
      var S: WideString);
    procedure tmrCheckFileNamesTimer(Sender: TObject);
    procedure cboAddPositionChange(Sender: TObject);
    procedure cboAdvancedAddPositionChange(Sender: TObject);
    procedure cboTrimAmountChange(Sender: TObject);
    procedure cboTrimFromChange(Sender: TObject);
    procedure txtAddPositionKeyPress(Sender: TObject; var Key: Char);
    procedure txtAdvancedAddASCII1KeyPress(Sender: TObject; var Key: Char);
    procedure txtAdvancedAddASCII2KeyPress(Sender: TObject; var Key: Char);
    procedure txtAutonumberStartKeyPress(Sender: TObject; var Key: Char);
    procedure txtTrimAmountKeyPress(Sender: TObject; var Key: Char);
    procedure txtPatternChange(Sender: TObject);
    procedure tmrMakeListsTimer(Sender: TObject);
    procedure tmrDoRenameTimer(Sender: TObject);
    procedure tmrRecursiveTimer(Sender: TObject);
    procedure cmdCancelClick(Sender: TObject);
    procedure cboPathClick(Sender: TObject);
    procedure tmrRefreshTimer(Sender: TObject);
    procedure lstvwLocalDblClick(Sender: TObject);

  private
    { Private declarations }
    function HasSubFolder(const Directory: string): Boolean;
    procedure LoadTreeDirectory;
    procedure AddSubFolders(const Directory: string; ParentNode: TTreeNode);
    procedure FindFiles(const Directory: string);
    procedure RemoveSelected(sList: TListView);
    function ExistsInList(const sFileName: String; const sPath: String): Boolean;
    function ReadFromINI(const Section : String; const Key : String; const Default : String) :String; overload;
    function ReadFromINI(const Section : String; const Key : String; const Default : LongInt) :LongInt; overload;
    function WriteToINI(const Section : String; const Key : String; const Value : String) :Boolean; overload;
    function WriteToINI(const Section : String; const Key : String; const Value : LongInt) :Boolean; overload;
    procedure HideAllGroups();
    function LogFiles(const path: String; const SRec: TSearchRec): Boolean;
    procedure Status(const sText: String);
    procedure ComboReadonly(cboBox: TComboBox);
    procedure MakeLists(const iFunction: Integer);
    procedure DoRename();

  public
    { Public declarations }
  end;
  TTreeFolderData = class
  private
    FPath: string;
    FHasSubFolders: Boolean;
    FOpened: Boolean;
  public
    constructor Create(const Path: string);
    destructor Destroy; override;
    property Path: string read FPath write FPath;
    property HasSubFolders: Boolean read FHasSubFolders write FHasSubFolders;
    property Opened: Boolean read FOpened write FOpened;
  end;

var
  frmMain: TfrmMain;
  curPath: String;
  sFolder: String;
  AppPath: String;
  INIFile: TINIFile;
  INIFileName: String;
  SkipLoad: Boolean;

implementation

uses StringH, FindH;

{$R *.xfm}



function TfrmMain.HasSubFolder(const Directory: string): Boolean;
var
  SearchRec: TSearchRec;
  Attributes: Integer;
begin
  // Do a peek to see if the given folder has at least one subfolder
  Result := False;
  Attributes := faAnyFile;
  if FindFirst(IncludeTrailingPathDelimiter(Directory) + '*',
    Attributes, SearchRec) = 0 then
  begin
    repeat
      if (SearchRec.Attr and faDirectory) > 0 then
        if (SearchRec.Name <> '.') and (SearchRec.Name <> '..') then
        begin
          Result := True;
          Break;
        end;
    until FindNext(SearchRec) <> 0;
    FindClose(SearchRec);
  end;
end;

procedure TfrmMain.LoadTreeDirectory;
var
  RootNode: TTreeNode;
  TreeFolderData: TTreeFolderData;

begin
  trvwLocal.Items.BeginUpdate;
  try
    trvwLocal.Items.Clear;
    RootNode := trvwLocal.Items.Add(nil, sFolder);
    RootNode.ImageIndex := 0;

    TreeFolderData := TTreeFolderData.Create(sFolder);
    TreeFolderData.Opened := True;
    RootNode.Data := TreeFolderData;
    AddSubFolders(sFolder, RootNode);
    RootNode.Expand(False);
  finally
    trvwLocal.Items.EndUpdate;
  end;

end;

procedure TfrmMain.AddSubFolders(const Directory: string;
  ParentNode: TTreeNode);
var
  SearchRec: TSearchRec;
  Attributes: Integer;
  NewNode: TTreeNode;
  TreeFolderData: TTreeFolderData;
begin
 Status('Loading folder...');
  trvwLocal.Items.BeginUpdate;
  try
    // First, delete any subfolders from the parent node.
    if ParentNode <> nil then
      ParentNode.DeleteChildren;

    Attributes := faAnyFile;
    if FindFirst(IncludeTrailingPathDelimiter(Directory) + '*',
      Attributes, SearchRec) = 0 then
    begin
      repeat
        if (SearchRec.Attr and faDirectory) > 0 then
          if (SearchRec.Name <> '.') and (SearchRec.Name <> '..') then
          begin
            NewNode := trvwLocal.Items.AddChild(ParentNode, SearchRec.Name);
            NewNode.ImageIndex := 0;
            TreeFolderData := TTreeFolderData.Create(
              IncludeTrailingPathDelimiter(Directory) + SearchRec.Name);
            NewNode.Data := TreeFolderData;

            if HasSubFolder(TreeFolderData.Path) then
            begin
              TreeFolderData.HasSubFolders := True;
              // Add a fake child so the + appears
              trvwLocal.Items.AddChild(newNode, '').ImageIndex := 0;
            end
          end;
      until FindNext(SearchRec) <> 0;
      FindClose(SearchRec);
    end;
  finally
    trvwLocal.Items.EndUpdate;
  end;
 Status(STATUS_READY);
end;

procedure TfrmMain.FindFiles(const Directory: string);
var
  SearchRec: TSearchRec;
  Attributes: Integer;
  Pixmap: QPixmapH;
  sComboPath: String;
begin
Status('Loading files...');
curPath := IncludeTrailingPathDelimiter(Directory);
cboPath.Text := curPath;

sComboPath := curPath;
if not (sComboPath = '/') then sComboPath := ExcludeTrailingPathDelimiter(curPath);
{$IFDEF MSWINDOWS}sComboPath := UpperCase(sComboPath);{$ENDIF}
if (cboPath.Items.IndexOf(sComboPath) < 0) then cboPath.Items.Add(sComboPath);


  // Find files for the local folder to be added to the list view
  lstvwLocal.Items.BeginUpdate;
  try
    lstvwLocal.Items.Clear;
    Attributes := faAnyFile;
    if FindFirst(IncludeTrailingPathDelimiter(Directory) + txtPattern.Text,
      Attributes, SearchRec) = 0 then
    begin
      repeat
        if (SearchRec.Attr and faDirectory) = 0 then
        begin
          with lstvwLocal.Items.Add do
          begin
            Caption := SearchRec.Name;
            ImageIndex := 0;
            SubItems.Add(IntToStr(SearchRec.Size));
            SubItems.Add(DateTimeToStr(FileDateToDateTime(SearchRec.Time)));
            // Work around for a bug in setting the image to nothing
            // Search the community site for information on how to modify
            // the VCL to have this fix.
            Pixmap := QPixmap_create;
            QListViewItem_setPixmap(Handle, 1, Pixmap);
            QListViewItem_setPixmap(Handle, 2, Pixmap);
            QPixmap_destroy(Pixmap);
          end;
        end;
      until FindNext(SearchRec) <> 0;
      FindClose(SearchRec);
    end;
  finally
    lstvwLocal.Items.EndUpdate;
    lstvwLocal.Sorted := True;
    lstvwLocal.Sorted := False;
  end;
 Status(STATUS_READY);
end;

{ TTreeFolderData }

constructor TTreeFolderData.Create(const Path: string);
begin
  FPath := Path;
  FHasSubFolders := False;
  FOpened := False;
end;

destructor TTreeFolderData.Destroy;
begin
  inherited;
end;

procedure TfrmMain.trvwLocalChange(Sender: TObject; Node: TTreeNode);
begin
if (SkipLoad) then exit;

if Node <> nil then FindFiles(TTreeFolderData(Node.Data).Path);
end;

procedure TfrmMain.trvwLocalCollapsed(Sender: TObject; Node: TTreeNode);
begin
  Node.ImageIndex := 0;
end;

procedure TfrmMain.trvwLocalDeletion(Sender: TObject; Node: TTreeNode);
var
  TreeFolderData: TTreeFolderData;
begin
  TreeFolderData := TTreeFolderData(Node.Data);
  if TreeFolderData <> nil then
    TreeFolderData.Free;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
SkipLoad := False;
Status('Loading settings...');
AppPath := ExtractFilePath(Application.ExeName);


{$IFDEF LINUX}
        cboPath.Text := '/';
        cboPath.Items.Add('/');
        INIFileName := IncludeTrailingPathDelimiter(getenv('HOME')) + '.RenameEm.ini';
{$ENDIF}

{$IFDEF MSWINDOWS}
        INIFileName := IncludeTrailingPathDelimiter(AppPath) + 'RenameEm.ini';
        sFolder := IncludeTrailingPathDelimiter(ExtractFileDrive(Application.ExeName));
        cboPath.Text := sFolder;
        cboPath.Items.Add('C:\');
        cboPath.Items.Add('D:\');
        cboPath.Items.Add('E:\');
        cboPath.Items.Add('F:\');
        cboPath.Items.Add('G:\');
        cboPath.Items.Add('H:\');
        cboPath.Items.Add('I:\');
        cboPath.Items.Add('J:\');
        cboPath.Items.Add('K:\');
        cboPath.Items.Add('L:\');
        cboPath.Items.Add('M:\');
        cboPath.Items.Add('N:\');
        cboPath.Items.Add('O:\');
        cboPath.Items.Add('P:\');
        cboPath.Items.Add('Q:\');
        cboPath.Items.Add('R:\');
        cboPath.Items.Add('S:\');
        cboPath.Items.Add('T:\');
        cboPath.Items.Add('U:\');
        cboPath.Items.Add('V:\');
        cboPath.Items.Add('W:\');
        cboPath.Items.Add('X:\');
        cboPath.Items.Add('Y:\');
        cboPath.Items.Add('Z:\');
        cboPath.Items.Add('A:\');
        cboPath.Items.Add('B:\');
{$ENDIF}

sFolder := ReadFromINI('Options', 'LastDir', sFolder);
{$IFDEF LINUX}if not (DirectoryExists(sFolder)) then sFolder := '/';{$ENDIF}
{$IFDEF MSWINDOWS}if not (DirectoryExists(sFolder)) then sFolder := 'C:\';{$ENDIF}

txtPattern.Text := ReadFromINI('Options', 'Pattern', '*');
if (ReadFromINI('Options', 'CaseSensitive', 0) = 1) then mnuCaseSensitive.Checked := True else mnuCaseSensitive.Checked := False;
if (ReadFromINI('Options', 'IncludeExtension', 0) = 1) then mnuIncludeExtension.Checked := True else mnuIncludeExtension.Checked := False;
if (ReadFromINI('Options', 'UndoFile', 1) = 1) then mnuUndo.Checked := True else mnuUndo.Checked := False;

Status('Loading folder view...');
curPath := sFolder;
cboPath.Text := sFolder;
LoadTreeDirectory();
FindFiles(curPath);

Status(STATUS_READY);
Self.WindowState := wsMaximized;
mnuRename_0.Click();
end;

procedure TfrmMain.trvwLocalExpanded(Sender: TObject; Node: TTreeNode);
var
  TreeFolderData: TTreeFolderData;
begin
  TreeFolderData := TTreeFolderData(Node.Data);
  if not TreeFolderData.Opened then
  begin
    TreeFolderData.Opened := True;
    AddSubFolders(TreeFolderData.Path, Node);
  end;
  Node.ImageIndex := 1;
end;

function TfrmMain.ReadFromINI(const Section : String; const Key : String; const Default : String) :String;
var
        ReadINI: TIniFile;

begin

try
        ReadFromINI := Default;
        ReadINI := TIniFile.Create(INIFileName);
        ReadFromINI := ReadINI.ReadString(Section, Key, Default);
finally
        ReadINI.Free;
end;

end;

function TfrmMain.ReadFromINI(const Section : String; const Key : String; const Default : LongInt) :LongInt;
var
        ReadINI: TIniFile;

begin

try
        ReadFromINI := Default;
        ReadINI := TIniFile.Create(INIFileName);
        ReadFromINI := ReadINI.ReadInteger(Section, Key, Default);
finally
        ReadINI.Free;
end;

end;


function TfrmMain.WriteToINI(const Section : String; const Key : String; const Value : String) :Boolean;
var
        WriteINI: TIniFile;

begin

try
        WriteINI := TIniFile.Create(INIFileName);
        WriteINI.WriteString(Section, Key, Value);
        WriteToINI := True;
finally
        WriteINI.Free;
end;

end;

function TfrmMain.WriteToINI(const Section : String; const Key : String; const Value : LongInt) :Boolean;
var
        WriteINI: TIniFile;

begin

try
        WriteToINI := False;
        WriteINI := TIniFile.Create(INIFileName);
        WriteINI.WriteInteger(Section, Key, Value);
        WriteToINI := True;
finally
        WriteINI.Free;
end;

end;

procedure TfrmMain.HideViewControls(const bVisible: Boolean);
begin
mnuRename.Enabled := bVisible;
mnuAdd.Enabled := bVisible;
mnuOptions.Enabled := bVisible;

cmdUp.Visible := bVisible;
trvwLocal.Visible := bVisible;
lstvwLocal.Visible := bVisible;
cboPath.Visible := bVisible;
txtPattern.Visible := bVisible;
lviFiles.Visible := bVisible;

lviRename.Visible := not bVisible;
FormResize(Self);

lviRename.Left := trvwLocal.Left;
lviRename.Top := cboPath.Top;
lviRename.Width := trvwLocal.Width + lstvwLocal.Width;
lviRename.Height := trvwLocal.Height;
end;

procedure TfrmMain.cmdRename_0Click(Sender: TObject);
var
        iFunction: Integer;
        
begin
iFunction := TComponent(Sender).Tag;
if (iFunction = 0) and (Length(txtReplaceFrom.Text) <= 0) then exit;
if (iFunction = 1) and (Length(txtAddText.Text) <= 0) then exit;
if (iFunction = 1) and (Length(txtAddPosition.Text) <= 0) then exit;
if (iFunction = 2) and (Length(txtAutonumberStart.Text) <= 0) then txtAutonumberStart.Text := '0';
if (iFunction = 4) and (Length(txtTrimAmount.Text) <= 0) then exit;
if (iFunction = 6) and (Length(txtAdvancedAddASCII1.Text) <= 0) then exit;
if (iFunction = 6) and (Length(txtAdvancedAddASCII2.Text) <= 0) then exit;
if (iFunction = 6) and (Length(txtAdvancedAddNew.Text) <= 0) then exit;
if (iFunction = 7) and (Length(txtID3Format.Text) <= 0) then exit;

grpConfirmation.Visible := True;
HideViewControls(False);
Status('Creating preview list...');

tmrMakeLists.Tag := iFunction;
tmrMakeLists.Enabled := True;
end;


procedure TfrmMain.tmrMakeListsTimer(Sender: TObject);
begin
tmrMakeLists.Enabled := False;
MakeLists(tmrMakeLists.Tag);
end;

procedure TfrmMain.MakeLists(const iFunction: Integer);
var
        sOldFileNameFull: String;
        sOldFileNameFullPath: String;
        sOldFileName: String;
        sNewFileName: String;
        sPath: String;
        iCase: Integer;
        bStart: Boolean;
        bTotalLen: Boolean;
        bBefore: Boolean;
        i: Integer;
        f: Integer;

begin
if (lviFiles.Items.Count <= 0) then begin
                                    mnuAllFiles.Click();
                                    lviFiles.Tag := 0;
                                    if (lviFiles.Items.Count <= 0) then begin
                                                                        Status(STATUS_READY);
                                                                        MessageDlg('No files selected', 'Please select the files and folders you wish to rename by adding them to the list.', mtInformation, [mbOK], 0);
                                                                        exit;
                                                                        end;
                                    end;


f := StrToIntDef(txtAutonumberStart.Text, 0);
iCase := 0;
if (optChangeCaseAllUppercase.Checked) then iCase := 0;
if (optChangeCaseAllLowercase.Checked) then iCase := 1;
if (optChangeCaseFirstUppercase.Checked) then iCase := 2;
if (optChangeCaseFirstLowercase.Checked) then iCase := 3;
if (optChangeCaseOpposite.Checked) then iCase := 4;
if (cboTrimFrom.Text = 'from start') then bStart := True else bStart := False;
if (cboTrimAmount.Text = 'trim the selected amount') then bTotalLen := False else bTotalLen := True;
if (cboAdvancedAddPosition.Text = 'before char') then bBefore := True else bBefore := False;

try

lviRename.Items.Clear();

for i := 0 to lviFiles.Items.Count - 1 do begin

         sOldFileNameFull := lviFiles.Items.Item[i].Caption;
         if (lviFiles.Items.Item[i].SubItems.Count > 0) then sOldFileNameFullPath := IncludeTrailingBackslash(lviFiles.Items.Item[i].SubItems.Strings[0]) + lviFiles.Items.Item[i].Caption else sOldFileNameFullPath := sOldFileNameFull; 
         if (mnuIncludeExtension.Checked) then sOldFileName := sOldFileNameFull else sOldFileName := RemoveFileExt(sOldFileNameFull);
         sNewFileName := sOldFileName;
         sPath := lviFiles.Items.Item[i].SubItems.Strings[0];

         if (iFunction = 0) then sNewFileName := fReplace(sOldFileName, txtReplaceFrom.Text, txtReplaceTo.Text, mnuCaseSensitive.Checked);
         if (iFunction = 1) then begin
                                 if (cboAddPosition.Text = 'to start') then sNewFileName := fAdd(sOldFileName, 0, txtAddText.Text);
                                 if (cboAddPosition.Text = 'to end') then sNewFileName := fAdd(sOldFileName, Length(sOldFileNameFull) + 10, txtAddText.Text);
                                 if (cboAddPosition.Text = 'to this position') then sNewFileName := fAdd(sOldFileName, StrToIntDef(txtAddPosition.Text, 0), txtAddText.Text);
                                 end;
         if (iFunction = 2) then begin
                                 if (chkAutonumberZero.Checked) then sNewFileName := fAutoNumber(AddString(IntToStr(f), IntToStr(lviFiles.Items.Count)), txtAutonumberBefore.Text, txtAutonumberAfter.Text);
                                 if not (chkAutonumberZero.Checked) then sNewFileName := fAutoNumber(IntToStr(f), txtAutonumberBefore.Text, txtAutonumberAfter.Text);
                                 end;
         if (iFunction = 3) then sNewFileName := fChangeCase(sOldFileName, iCase);
         if (iFunction = 4) then sNewFileName := fTrim(sOldFileName, StrToIntDef(txtTrimAmount.Text, 0), bStart, bTotalLen);
         if (iFunction = 5) then sNewFileName := fExtension(sOldFileNameFull, txtExtension.Text);
         if (iFunction = 6) then sNewFileName := fAdvancedAdd(sOldFileName, StrToIntDef(txtAdvancedAddASCII1.Text, 0), StrToIntDef(txtAdvancedAddASCII2.Text, 0), txtAdvancedAddNew.Text, bBefore);
         if (iFunction = 7) then sNewFileName := fFileNamesFromID3(sOldFileNameFullPath, txtID3Format.Text);

         if not (mnuIncludeExtension.Checked) and (iFunction <> 5) then sNewFileName := sNewFileName + ExtractFileExt(sOldFileNameFull);

          with lviRename.Items.Add do
          begin
            Caption := sNewFileName;
            ImageIndex := 0;
            SubItems.Add(sOldFileNameFull);
            SubItems.Add(sPath);
          end;

         f := f + 1;
end;

except
end;



CheckFileNames(True);





Status(STATUS_READY);

end;

procedure TfrmMain.CheckFileNames(const bNag: Boolean);
var
        i: Integer;
        f: Integer;
        iCount: Integer;

begin
// Checks, if there are more than one same filename generated in same folder and if the filenames are valid.
cmdYes.Enabled := False;

for i := 0 to lviRename.Items.Count - 1 do begin
         iCount := 0;
         if not (IsValidFileName(lviRename.Items.Item[i].Caption)) then begin
                                                                        if (bNag) then MessageDlg('Error', 'There are invalid filenames. This rename cannot be completed until you change them.', mtError, [mbOK], 0);
                                                                        exit;
                                                                        end;

         for f := 0 to lviRename.Items.Count - 1 do begin
                  if (lviRename.Items.Item[f].Caption = lviRename.Items.Item[i].Caption) and (lviRename.Items.Item[f].SubItems.Strings[1] = lviRename.Items.Item[i].SubItems.Strings[1]) then begin
                                                                                               iCount := iCount + 1;
                                                                                               end;
                  if (iCount > 1) then begin
                                       if (bNag) then MessageDlg('Error', 'There are conflicting filenames. This rename cannot be completed until you change them.', mtError, [mbOK], 0);
                                       exit;
                                       end;

         end;

end;

cmdYes.Enabled := True;
end;

procedure TfrmMain.mnuExitClick(Sender: TObject);
begin
Self.Close();
end;

procedure TfrmMain.About2Click(Sender: TObject);
begin
ShowMessage('Rename ''Em v7.2' + ENTER + 'by Antti Kirjavainen' + ENTER + ENTER + 'antti.kirjavainen@net-tools.org' + ENTER + 'http://www.net-tools.org');
end;

procedure TfrmMain.txtPathKeyPress(Sender: TObject; var Key: Char);
begin
if (Ord(Key) <> 13) and (Ord(Key) <> 10) then exit;

cmdUp.Click();
end;

procedure TfrmMain.FormResize(Sender: TObject);
var
        iHalfOfMainX: Integer;
        grpR: TGroupBox;
        i: Integer;

begin
iHalfOfMainX := (Self.Width div 2) - (grpRename_0.Width div 2) - 10;

trvwLocal.Width := iHalfOfMainX;
trvwLocal.Height := Self.Height - 80;
lstvwLocal.Left := trvwLocal.Left + trvwLocal.Width;
lstvwLocal.Width := iHalfOfMainX;
lstvwLocal.Height := trvwLocal.Height;
grpRename_0.Left := lstvwLocal.Left + lstvwLocal.Width + 5;

cboPath.Width := trvwLocal.Width - cmdUp.Width;
txtPattern.Left := trvwLocal.Left + trvwLocal.Width;
txtPattern.Width := lstvwLocal.Width;

lviFiles.Left := lstvwLocal.Left + lstvwLocal.Width + 5;
lviFiles.Height := Self.Height - grpRename_0.Height - 55;

for i := 1 to 7 do begin
        grpR := TGroupBox(FindComponent('grpRename_' + IntToStr(i)));
        grpR.Left := grpRename_0.Left;
end;

grpConfirmation.Left := grpRename_0.Left;
grpLoading.Left := grpRename_0.Left;
end;

procedure TfrmMain.mnuRefreshClick(Sender: TObject);
begin
FindFiles(curPath);
lstvwLocal.Sorted := True;
lstvwLocal.Sorted := False;
end;

procedure TfrmMain.mnuCaseSensitiveClick(Sender: TObject);
begin
mnuCaseSensitive.Checked := not mnuCaseSensitive.Checked;
end;

procedure TfrmMain.mnuIncludeExtensionClick(Sender: TObject);
begin
mnuIncludeExtension.Checked := not mnuIncludeExtension.Checked;
end;

procedure TfrmMain.mnuUndoClick(Sender: TObject);
begin
mnuUndo.Checked := not mnuUndo.Checked;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
WriteToINI('Options', 'LastDir', cboPath.Text);
WriteToINI('Options', 'Pattern', txtPattern.Text);
if (mnuCaseSensitive.Checked) then WriteToINI('Options', 'CaseSensitive', 1) else WriteToINI('Options', 'CaseSensitive', 0);
if (mnuIncludeExtension.Checked) then WriteToINI('Options', 'IncludeExtension', 1) else WriteToINI('Options', 'IncludeExtension', 0);
if (mnuUndo.Checked) then WriteToINI('Options', 'UndoFile', 1) else WriteToINI('Options', 'UndoFile', 0);
end;

procedure TfrmMain.cmdUpClick(Sender: TObject);
var
        sNewPath: String;
        sComboPath: String;

begin

sNewPath := ExcludeTrailingPathDelimiter(cboPath.Text);

{$IFDEF LINUX}
if (Length(cboPath.Text) <= 0) then cboPath.Text := '/';
//if (curPath = '/') then exit;
{$ENDIF}

{$IFDEF MSWINDOWS}if (Length(cboPath.Text) <= 0) then cboPath.Text := 'C:\';{$ENDIF}


if not (DirectoryExists(sNewPath)) then begin
                                                                        {$IFDEF LINUX}
                                                                        if (Length(sNewPath) <= 0) then sNewPath := '/';
                                                                        if (sNewPath <> '/') then begin
                                                                        {$ENDIF}
                                                                         MessageDlg('Error', 'The specified path does not exist!', mtError, [mbOK], 0);
                                                                         cboPath.Text := curPath;
                                                                         exit;
                                                                        {$IFDEF LINUX}
                                                                                                  end;
                                                                        {$ENDIF}
                                                                         end;


if (Length(ExcludeTrailingPathDelimiter(curPath)) = Length(sNewPath)) then sNewPath := ExtractFilePath(sNewPath);
sNewPath := IncludeTrailingPathDelimiter(sNewPath);

sComboPath := sNewPath;
if not (sComboPath = '/') then sComboPath := ExcludeTrailingPathDelimiter(sNewPath);
{$IFDEF MSWINDOWS}sComboPath := UpperCase(sComboPath);{$ENDIF}
if (cboPath.Items.IndexOf(sComboPath) < 0) then cboPath.Items.Add(sComboPath);

cboPath.Text := sNewPath;
curPath := cboPath.Text;
sFolder := cboPath.Text;

SkipLoad := True;
LoadTreeDirectory();
SkipLoad := False;
mnuRefresh.Click();

cboPath.Text := sNewPath;
curPath := sNewPath;
end;

procedure TfrmMain.RemoveSelected(sList: TListView);
var
        i: Integer;

begin
if (sList.SelCount <= 0) then exit;

for i := 0 to sList.Items.Count - 1 do begin
         if (sList.Items.Item[i].Selected) then begin
                                                sList.Items.Item[i].Delete;
                                                exit;
                                                end;
end;
 
end;

function TfrmMain.ExistsInList(const sFileName: String; const sPath: String): Boolean;
var
        i: Integer;

begin
for i := 0 to lviFiles.Items.Count - 1 do begin
         if (lviFiles.Items.Item[i].Caption = sFileName) then begin
                                                              if (lviFiles.Items.Item[i].SubItems.Strings[0] = sPath) then begin
                                                                                                                           Result := True;
                                                                                                                           exit;
                                                                                                                           end;
                                                              end;
end;

Result := False;
end;

procedure TfrmMain.mnuSelectedFilesClick(Sender: TObject);
var
        i: Integer;
        sFileName: String;
        sPath: String;

begin
if (lstvwLocal.SelCount <= 0) then exit;

lviFiles.Tag := 1;
sPath := ExcludeTrailingPathDelimiter(curPath);

for i := 0 to lstvwLocal.Items.Count - 1 do begin
    if (lstvwLocal.Items.Item[i].Selected) then begin
          sFileName := lstvwLocal.Items.Item[i].Caption;

       if not (ExistsInList(sFileName, sPath)) then begin
          with lviFiles.Items.Add do
          begin
            Caption := sFileName;
            ImageIndex := 0;
            SubItems.Add(sPath);
          end;
       end;
    end;
end;

end;

procedure TfrmMain.lviFilesDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
Accept := True;
mnuSelectedFiles.Click();
end;

procedure TfrmMain.lstvwLocalDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
Accept := False;
mnuClearSelected.Click();
end;

procedure TfrmMain.mnuClearSelectedClick(Sender: TObject);
begin
lviFiles.Tag := 1;
RemoveSelected(lviFiles);
end;

procedure TfrmMain.mnuClearClick(Sender: TObject);
begin
lviFiles.Tag := 0;
lviFiles.Items.Clear();
end;

procedure TfrmMain.mnuAllFilesClick(Sender: TObject);
var
        i: Integer;
        sFileName: String;
        sPath: String;

begin
if (lstvwLocal.Items.Count <= 0) then exit;

sPath := ExcludeTrailingPathDelimiter(curPath);
lviFiles.Tag := 1;

for i := 0 to lstvwLocal.Items.Count - 1 do begin
          sFileName := lstvwLocal.Items.Item[i].Caption;

       if not (ExistsInList(sFileName, sPath)) then begin
          with lviFiles.Items.Add do
          begin
            Caption := sFileName;
            ImageIndex := 0;
            SubItems.Add(sPath);
          end;
       end;
end;

end;

procedure TfrmMain.mnuFolderNameClick(Sender: TObject);
var
        sFileName: String;
        sPath: String;

begin
sPath := ExcludeTrailingPathDelimiter(curPath);
sFileName := ExtractFileName(sPath);
sPath := ExtractFilePath(sPath);
if (Length(sFileName) <= 0) then exit;

lviFiles.Tag := 1;

if not (ExistsInList(sFileName, sPath)) then begin
          with lviFiles.Items.Add do
          begin
            Caption := sFileName;
            ImageIndex := 0;
            SubItems.Add(sPath);
          end;
          end;
end;

function TfrmMain.LogFiles(const path: String; const SRec: TSearchRec): Boolean;
var
        sFileName: String;
        sPath: String;

begin
sFileName := SRec.Name;
sPath := ExcludeTrailingPathDelimiter(path);
if (DirectoryExists(IncludeTrailingPathDelimiter(sPath) + sFileName)) then begin
                                                                           Result := False;
                                                                           exit;
                                                                           end;

if not (ExistsInList(sFileName, sPath)) then begin
          with lviFiles.Items.Add do
          begin
            Caption := sFileName;
            ImageIndex := 0;
            SubItems.Add(sPath);
          end;
          end;

Status('Searching ' + path + '...');
if (cmdCancel.Tag = 1) then Result := False else Result := True;
end;


procedure TfrmMain.mnuAllFilesRecursiveClick(Sender: TObject);
begin
Status('Searching ' + curPath + '...');
tmrRecursive.Enabled := True;
end;

procedure TfrmMain.Status(const sText: String);
begin
stbStatus.SimpleText := sText;
if not (copy(sText, 1 ,5) = 'Ready') then begin
                                          Self.Cursor := crHourGlass;
                                          grpLoading.Cursor := crHourGlass;
                                          lviRename.Cursor := crHourGlass;
                                          grpLoading.Visible := True;
                                          lblLoading.Caption := sText;
                                          cmdCancel.Tag := 0;
                                          end
                                          else begin
                                          Self.Cursor := crDefault;
                                          grpLoading.Cursor := crDefault;
                                          lviRename.Cursor := crDefault;
                                          grpLoading.Visible := False;
                                          end;
end;

procedure TfrmMain.lstvwLocalEdited(Sender: TObject; Item: TListItem;
  var S: WideString);
var
        bSuccess: Boolean;

begin
if (Item.Caption = S) then exit;

bSuccess := RenameFile(IncludeTrailingPathDelimiter(curPath) + Item.Caption, IncludeTrailingPathDelimiter(curPath) + S);
if not (bSuccess) then begin
                       MessageDlg('Error', 'Renaming failed. Make sure the file is not in use and that you have appropriate permissions.', mtError, [mbOK], 0);
                       exit;
                       end;

tmrRefresh.Enabled := True;
end;

procedure TfrmMain.lviFilesItemMouseDown(Sender: TObject;
  Button: TMouseButton; Item: TListItem; const Pt: TPoint;
  ColIndex: Integer);
var
   curPos : TPoint;

begin
if (lviFiles.SelCount = 0) then exit;

if (Button = mbRight) then begin
                           GetCursorPos(curPos);
                           mnuPopUpFiles.Popup(curPos.x, curPos.y);
                           end;


end;

procedure TfrmMain.mnuDeleteFileClick(Sender: TObject);
var
        sFileName: String;
        sPath: String;
        iErrorCount: Integer;
        i: Integer;
        bSuccess: Boolean;

begin
iErrorCount := 0;
if (MessageDlg('Delete file', 'Are you sure you want to delete the selected files?', mtConfirmation, [mbYes, mbNo], 0) = mrYes) then begin
                        for i := 0 to lstvwLocal.Items.Count - 1 do begin
                                if (lstvwLocal.Items.Item[i].Selected) then begin
                                                                            sFileName := lstvwLocal.Items.Item[i].Caption;
                                                                            sPath := IncludeTrailingPathDelimiter(curPath);
                                                                            bSuccess := DeleteFile(sPath + sFileName);
                                                                            if not (bSuccess) then iErrorCount := iErrorCount + 1;
                                                                            end;
                        end;
                                                                end;

if (iErrorCount > 0) then Status('Ready, failed to delete ' + IntToStr(iErrorCount) + ' of the selected files.') else Status(STATUS_READY);
mnuRefresh.Click();
end;

procedure TfrmMain.lstvwLocalItemMouseDown(Sender: TObject;
  Button: TMouseButton; Item: TListItem; const Pt: TPoint;
  ColIndex: Integer);
var
   curPos : TPoint;

begin
if (lstvwLocal.SelCount = 0) then exit;

if (Button = mbRight) then begin
                           GetCursorPos(curPos);
                           mnuPopUpLocal.Popup(curPos.x, curPos.y);
                           end;


end;

procedure TfrmMain.mnuRemoveFromListClick(Sender: TObject);
begin
// If filenames are now, after removing some, valid, enable cmdYes:
RemoveSelected(lviRename);
if (lviRename.Items.Count <= 0) then cmdNo.Click() else CheckFileNames(False); // If the list is empty, cancel
end;

procedure TfrmMain.lviRenameMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   curPos : TPoint;

begin
if (lviRename.SelCount = 0) then exit;

if (Button = mbRight) then begin
                           GetCursorPos(curPos);
                           mnuPopUpRename.Popup(curPos.x, curPos.y);
                           end;

end;

procedure TfrmMain.mnuAddClick(Sender: TObject);
begin
if (lstvwLocal.SelCount <= 0) then begin
                                   mnuSelectedFiles.Enabled := False;
                                   end
                                   else begin
                                   mnuSelectedFiles.Enabled := True;
                                   end;
if (lviFiles.SelCount <= 0) then begin
                                   mnuClearSelected.Enabled := False;
                                   end
                                   else begin
                                   mnuClearSelected.Enabled := True;
                                   end;
if (lviFiles.Items.Count <= 0) then begin
                                    mnuClear.Enabled := False;
                                    end
                                    else begin
                                    mnuClear.Enabled := True;
                                    end;
end;

procedure TfrmMain.HideAllGroups();
var
        i: Integer;
        grpR: TGroupBox;
        mnuR: TMenuItem;

begin

grpLoading.Visible := False;

for i := 0 to 7 do begin
        grpR := TGroupBox(FindComponent('grpRename_' + IntToStr(i)));
        grpR.Visible := False;
        mnuR := TMenuItem(FindComponent('mnuRename_' + IntToStr(i)));
        mnuR.Checked := False;
end;

end;

procedure TfrmMain.ComboReadonly(cboBox: TComboBox);
var
        i: Integer;

begin
// Don't allow editing the ComboBoxes:
for i := 0 to cboBox.Items.Count - 1 do begin
         if (cboBox.Text = cboBox.Items.Strings[i]) then exit;
end;

cboBox.Text := cboBox.Items.Strings[0];
end;

procedure TfrmMain.mnuRename_0Click(Sender: TObject);
var
        mnuR: TMenuItem;
        grpR: TGroupBox;

begin
HideAllGroups();

grpR := TGroupBox(FindComponent('grpRename_' + IntToStr(TComponent(Sender).Tag)));
mnuR := TMenuItem(FindComponent('mnuRename_' + IntToStr(TComponent(Sender).Tag)));
mnuR.Checked := True;
grpR.Visible := True;
end;

procedure TfrmMain.cboAddPositionSelect(Sender: TObject);
begin
if (cboAddPosition.Text = 'to this position') then txtAddPosition.Enabled := True else txtAddPosition.Enabled := False;
end;

procedure TfrmMain.txtExtensionKeyPress(Sender: TObject; var Key: Char);
begin
if (Ord(Key) = 46) then Key := Chr(0);
end;

procedure TfrmMain.cmdNoClick(Sender: TObject);
begin
grpConfirmation.Visible := False;
Status('Clearing lists...');
lviRename.Items.Clear();
if (lviFiles.Tag = 0) then begin
                           lviFiles.Items.Clear();
                           end;
Status(STATUS_READY);
HideViewControls(True);
end;

procedure TfrmMain.lviRenameDblClick(Sender: TObject);
var
        sOldFileName: String;
        sNewFileName: String;
        sText: String;
        sPath: String;

begin
if (lviRename.SelCount <= 0) then exit;

sNewFileName := lviRename.Selected.Caption;
sOldFileName := lviRename.Selected.SubItems.Strings[0];
sPath := lviRename.Selected.SubItems.Strings[1];

if not (IsValidFileName(sNewFileName)) then begin
                                            MessageDlg('Rename to be done', sNewFileName + ENTER + ENTER + 'Invalid filename!', mtError, [mbOK], 0);
                                            exit;
                                            end;

if not (sNewFileName = sOldFileName) then sText := sPath + ENTER + ENTER + sOldFileName + ENTER + sNewFileName else sText := IncludeTrailingPathDelimiter(sPath) + sOldFileName + ENTER + ENTER + 'No changes.';
MessageDlg('Rename to be done', sText, mtInformation, [mbOK], 0);

end;

procedure TfrmMain.cmdYesClick(Sender: TObject);
begin
cmdYes.Enabled := False;
grpConfirmation.Visible := False;
Status('Performing rename...');

tmrDoRename.Enabled := True;
end;

procedure TfrmMain.DoRename();
var
        sNewFileName: String;
        sOldFileName: String;
        iErrorCount: Integer;
        iRenameCount: Integer;
        bSuccess: Boolean;
        UndoFile: TStringList;
        sPath: String;
        i: Integer;

begin

iErrorCount := 0;
iRenameCount := 0;
UndoFile := TStringList.Create();
UndoFile.Clear();

try
for i := 0 to lviRename.Items.Count - 1 do begin
         sNewFileName := lviRename.Items.Item[i].Caption;
         sOldFileName := lviRename.Items.Item[i].SubItems.Strings[0];
         sPath := IncludeTrailingPathDelimiter(lviRename.Items.Item[i].SubItems.Strings[1]);

         if (sNewFileName <> sOldFileName) then begin
                                                bSuccess := RenameFile(sPath + sOldFileName, sPath + sNewFileName);
                                                if not (bSuccess) then iErrorCount := iErrorCount + 1 else iRenameCount := iRenameCount + 1;

                                                {$IFDEF MSWINDOWS}UndoFile.Add('REN "' + sPath + sNewFileName + '" "' + sOldFileName + '"');{$ENDIF}
                                                {$IFDEF LINUX}UndoFile.Add('mv "' + sPath + sNewFileName + '" "' + sPath + sOldFileName + '"');{$ENDIF}
                                                end;
end;

finally
        lviFiles.Items.Clear();
        mnuRefresh.Click();
        cmdNo.Click();
        Status('Ready, renamed ' + IntToStr(iRenameCount) + ' file(s)/folder(s), ' + IntToStr(iErrorCount) + ' error(s).');
        {$IFDEF MSWINDOWS}if (mnuUndo.Checked) then UndoFile.SaveToFile(AppPath + 'UNDO.BAT');{$ENDIF}
        {$IFDEF LINUX}if (mnuUndo.Checked) then UndoFile.SaveToFile(AppPath + 'UNDO');{$ENDIF}
end;

end;

procedure TfrmMain.lviRenameEdited(Sender: TObject; Item: TListItem;
  var S: WideString);
begin
// If filenames are now, after editing, valid, enable cmdYes:
tmrCheckFileNames.Enabled := True;
end;

procedure TfrmMain.tmrCheckFileNamesTimer(Sender: TObject);
begin
tmrCheckFileNames.Enabled := False;
CheckFileNames(False);
end;

procedure TfrmMain.cboAddPositionChange(Sender: TObject);
begin
ComboReadonly(cboAddPosition);
end;

procedure TfrmMain.cboAdvancedAddPositionChange(Sender: TObject);
begin
ComboReadonly(cboAdvancedAddPosition);
end;

procedure TfrmMain.cboTrimAmountChange(Sender: TObject);
begin
ComboReadonly(cboTrimAmount);
end;

procedure TfrmMain.cboTrimFromChange(Sender: TObject);
begin
ComboReadonly(cboTrimFrom);
end;

procedure TfrmMain.txtAddPositionKeyPress(Sender: TObject; var Key: Char);
begin
Key := OnlyNumeric(Key);
end;

procedure TfrmMain.txtAdvancedAddASCII1KeyPress(Sender: TObject;
  var Key: Char);
begin
Key := OnlyNumeric(Key);
end;

procedure TfrmMain.txtAdvancedAddASCII2KeyPress(Sender: TObject;
  var Key: Char);
begin
Key := OnlyNumeric(Key);
end;

procedure TfrmMain.txtAutonumberStartKeyPress(Sender: TObject;
  var Key: Char);
begin
Key := OnlyNumeric(Key);
end;

procedure TfrmMain.txtTrimAmountKeyPress(Sender: TObject; var Key: Char);
begin
Key := OnlyNumeric(Key);
end;

procedure TfrmMain.txtPatternChange(Sender: TObject);
begin
FindFiles(curPath);
end;

procedure TfrmMain.tmrDoRenameTimer(Sender: TObject);
begin
tmrDoRename.Enabled := False;
DoRename();
end;

procedure TfrmMain.tmrRecursiveTimer(Sender: TObject);
begin
FindRecursive(curPath, txtPattern.Text, LogFiles);
lviFiles.Tag := 1;
Status(STATUS_READY);
end;

procedure TfrmMain.cmdCancelClick(Sender: TObject);
begin
cmdCancel.Tag := 1;
end;

procedure TfrmMain.cboPathClick(Sender: TObject);
begin
cmdUp.Click();
end;

procedure TfrmMain.tmrRefreshTimer(Sender: TObject);
begin
tmrRefresh.Enabled := False;
mnuRefresh.Click();
end;

procedure TfrmMain.lstvwLocalDblClick(Sender: TObject);
begin
mnuAddFile2.Click();
end;

end.
